;-------------------------------------------------------------------------------
;[`
sound_init
	lda	#%00011111
	sta	$4015
	lda	#$00
	sta	<$a0
	sta	<$a2
	sta	<$a4
	sta	<$a6
	sta	<$70
	sta	<$72
	sta	<$74
	sta	<$76


	lda	#$01
	sta	<$c0
	sta	<$c2
	sta	<$c4
	sta	<$c6

	ldy	#$00
sound_channel_set:
	lda	<$f0			;
	cmp	#$04			;
	beq	return4			;`lȏȂI
	asl	a
	tax				;2{xɊi[
	lda	sound_data_table,x
	sta	<$e0,x			;f[^Jnʒu
	inx
	lda	sound_data_table,x
	sta	<$e0,x			;f[^Jnʒu
	inc	<$f0
	jmp	sound_channel_set
return4
	lda	#$00
	sta	<$f0
	rts
;-------------------------------------------------------------------------------
sound_driver_start:

	lda	<$f0
	cmp	#$04
	beq	sound_channel_reset	;$f004Ȃ炨I
	asl	a
	tax
	dec	<$c0,x			;JE^炵
	bne	return1			;[ȊOȂJE^炵ĂI

	jsr	sound_data_read		;[ȂTEhǂݍ

	lda	<$70,x
	and	#%00000100
	cmp	#%00000100
	bne	enve_write
	jsr	sound_duty_select	;iHjF`

enve_write:
	lda	<$70,x
	and	#%00000001
	cmp	#%00000001
	bne	freq_write
	jsr	sound_software_enverope	;Gx[v`

freq_write:
	jsr	sound_data_write	;ăf[^o
	inc	<$f0			;̃`lݒ肵
	jmp	sound_driver_start	;͂߂ɖ߂

return1:
	lda	<$70,x
	and	#%00000100
	cmp	#%00000100
	bne	enve_write2

	lda	<$70,x
	and	#%00001000
	cmp	#%00001000
	beq	enve_write2		
	jsr	sound_duty_select

enve_write2:

	lda	<$70,x
	and	#%00000001
	cmp	#%00000001
	bne	return7

	lda	<$70,x
	and	#%00000010
	cmp	#%00000010
	beq	return7			;IĂ΂̂܂܂I
	jsr	sound_software_enverope

return7:
	inc	<$f0			;̃`lݒ肵
	jmp	sound_driver_start	;͂߂ɖ߂

sound_channel_reset:

	lda	#$00
	sta	<$f0
	rts				;łI
;-------------------------------------------------------------------------------
frequency_set:

	lda	<$f0
	asl	a
	tax
	lda	<$B0,x			;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a
	tay

	lda	<$f0
	cmp	#$03
	beq	noise_frequency_get	;S`lڂȂmCYg擾

	lda	psg_frequency_table,y	;PSGge[uLowǂݏo
	sta	<$D1,x			;
	iny				;yP₵
	lda	psg_frequency_table,y	;PSGge[uHighǂݏo
	sta	<$D0,x			;

oct_set1:

	lda	<$B0,x			;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;
	beq	freq_end		;[Ȃ炻̂܂܏I
	tay				;

oct_set2:

	lsr	<$D0,x			;IN^[uݒ
	ror	<$D1,x			;IN^[uݒ
	dey				;
	bne	oct_set2		;IN^[uJԂ

freq_end:

	rts

noise_frequency_get:
	lda	noise_frequency_table,y	;ge[uLowǂݏo
	sta	<$D1,x			;
	iny				;yP₵
	lda	noise_frequency_table,y	;ge[uHighǂݏo
	sta	<$D0,x			;
	jmp	oct_set1
;-------------------------------------------------------------------------------
sound_data_read:
	jsr	reg400x
	lda	<$70,x
	and	#%11110101
	sta	<$70,x			;\tgGxf[eBGhw薳ݒ

	lda	<$10,x
	asl	a
	tay
	lda	duty_select_table,y	;f[eBZNgAhXݒ
	sta	<$00,x			;
	iny				;
	lda	duty_select_table,y	;
	sta	<$01,x			;

	lda	<$80,x			;Gxf[^ԍ
	asl	a
	tay
	lda	enverope_table,y	;
	sta	<$60,x			;
	iny
	lda	enverope_table,y
	sta	<$61,x			;f[^Jnʒu

	jsr	reg400x
	lda	[$e0,x]			;f[^ǂݍ
;----------
;f[^Ghݒ
	cmp	#$FF			;f[^$FFȂJԂƂ
	bne	duty_set		;ꂾƃYFȂ
					;Aʂɂ܂Ȃ
	lda	loop_point_table,x
	sta	<$e0,x			;[vJnʒu Low
	inx
	lda	loop_point_table,x
	sta	<$e0,x			;[vJnʒu High
	jmp	sound_data_read
;----------
;Fݒ
duty_set:
	cmp	#$fe
	bne	volume_set
	jsr	sound_data_address
	lda	[$e0,x]			;Ff[^ǂݏo
	pha
	and	#%10000000		;8bitڊmF
	cmp	#%10000000
	bne	duty_select_part	;iHjF

duty_part:
	lda	<$70,x
	and	#%11111011
	ora	#%00001000		;Ԃ悭킩񂪔ÔߓƂ
	sta	<$70,x			;f[eBZNgw

	pla
	asl	a
	asl	a
	asl	a
	asl	a
	sta	<$50,x			;

	jsr	sound_data_address
	jsr	reg400x
	lda	[$e0,x]
	sta	$4001,y
	jsr	sound_data_address
	jmp	sound_data_read

duty_select_part:
	lda	<$70,x
	ora	#%00000100
	sta	<$70,x			;f[eBZNgLw

	pla
	sta	<$10,x
	asl	a
	tay
	lda	duty_select_table,y	;f[eBZNgAhXݒ
	sta	<$00,x			;
	iny				;
	lda	duty_select_table,y	;
	sta	<$01,x			;
	jsr	sound_data_address
	jsr	sound_data_address	;QoCgږ
	jmp	sound_data_read

;----------
;ʐݒ
volume_set:
	cmp	#$fd
	bne	oto_set
	jsr	sound_data_address
	lda	[$e0,x]			;
	pha
	and	#%10000000		;8bitڊmF
	cmp	#%10000000
	bne	softenve_part		;\tgGx

volume_part:
	lda	<$70,x
	and	#%11111110
	ora	#%00000010		;Ԃ悭킩񂪔ÔߓƂ
	sta	<$70,x			;\tgGxw

	pla
	and	#%00001111
	ora	<$50,x
	sta	$4000,y			;{[
	jsr	sound_data_address
	jmp	sound_data_read

softenve_part:
	lda	<$70,x
	ora	#%00000001
	sta	<$70,x			;\tgGxLw

	pla
	sta	<$80,x
	asl	a
	tay
	lda	enverope_table,y	;Gxf[^AhXݒ
	sta	<$60,x			;
	iny				;
	lda	enverope_table,y	;
	sta	<$61,x			;
	jsr	sound_data_address
	jmp	sound_data_read

;----------

oto_set:
	sta	<$B0,x			;͂܂
	jsr	sound_data_address
	lda	[$e0,x]			;ǂݏo
	sta	<$C0,x			;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	jsr	frequency_set		;gZbg
	rts

sound_data_address:
	inc	<$e0,x			;f[^AhX{P
	bne	return2			;ʂオ
	inc	<$e1,x			;f[^AhXS̈ʁij{P
return2:
	rts
;-------------------------------------------------------------------------------
sound_data_write:
	jsr	reg400x
	lda	<$f0
	cmp	#$03
	beq	noise_cut

write:
	lda	<$D1,x			;Low Write
	sta	$4002,y
	lda	<$D0,x			;High Write
	sta	$4003,y
	rts

noise_cut:
	lda	<$b0,x
	cmp	#$fc			;mCYŋxȂ΂
	bne	write			;
	rts
;-------------------------------------------------------------------------------
sound_software_enverope:
	jsr	reg400x
	lda	<$b0,x
	cmp	#$fc
	beq	return9

	lda	<$f0
	cmp	#$02
	beq	return6			;OpgȂ΂`

	lda	[$60,x]			;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return3			;ŌȂ炻̂܂܂܂

	ora	<$50,x			;Ff[^i4bitjƉ4bitőZ
	sta	$4000,y			;݁`
	jsr	enverope_address	;AhX₵
	rts				;܂
return9:
	lda	<$50,x
	sta	$4000,y			;{[[̏
	rts
return3:
	lda	<$70,x
	ora	#%00000010
	sta	<$70,x			;\tgGxf[^GhwLݒ
return6:
	rts

;-------------------------------------------------------------------------------
enverope_address:
	inc	<$60,x
	bne	return5
	inc	<$61,x
return5:
	rts
;--------------------------------------	
reg400x:
	lda	<$f0
	asl	a
	tax
	asl	a
	tay
	rts
;-------------------------------------------------------------------------------
sound_duty_select:
	jsr	reg400x

	lda	<$f0
	cmp	#$02
	beq	return21		;OpgȂ΂`

	lda	[$00,x]			;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return22		;ŌȂ炻̂܂܂܂
	asl	a
	asl	a
	asl	a
	asl	a
	sta	<$50,x			;Ff[^i4bitjƉ4bitőZ
;	sta	$4000,y			;݁`
	jsr	duty_select_address	;AhX₵
	rts				;܂

return22:
	lda	<$70,x
	ora	#%00001000
	sta	<$70,x			;\tgGxf[^GhwLݒ
return21:
	rts

;-------------------------------------------------------------------------------
duty_select_address:
	inc	<$00,x
	bne	return23
	inc	<$01,x
return23:
	rts
;--------------------------------------	
